async function requestPermission(name) {
    switch(tizen.ppm.checkPermission(name)) {
    case "PPM_ALLOW":
        return true
    case "PPM_DENY":
        return false
    case "PPM_ASK":
        const result = await new Promise((resolve, reject) => {
            tizen.ppm.requestPermission(name, resolve, reject)
        })
        return result === "PPM_ALLOW_FOREVER"
    }
}

async function requestPermissionsAll(names) {
    const result = {}

    for(const name of names) {
        result[name] = await requestPermission(name)
    }

    result.all = Object.values(result).every(r => r)
    return result
}

function processModelOutput(y) {
    const rawData = y.getTensorRawData(0)
    y = [...rawData.data]
        .map((v, i) => [i, v])
        .filter(([_, v]) => v >= 0.01)
        .sort((a, b) => b[1] - a[1])
        .slice(0, 3)
    return y
}
