class Logger {
    static instance = new Logger()
    #callbacks = new Set()
    logs = []

    #log(level, message) {
        const log = {
            timestamp: new Date(),
            level: level,
            message: message,
        }
        console.log(`${level}: ${message}`)
        this.logs.push(log)
        this.#callbacks.forEach(c => c(log))
    }

    debug(message) {
        this.#log("debug", message)
    }

    info(message) {
        this.#log("info", message)
    }

    error(message) {
        this.#log("error", message)
    }

    addEventListener(callback) {
        this.#callbacks.add(callback)
    }

    removeEventListener(callback) {
        this.#callbacks.delete(callback)
    }
}
